(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@cypress/webpack-dev-server'), require('@ngtools/webpack'), require('fs')) :
  typeof define === 'function' && define.amd ? define('cypress-angular-dev-server', ['exports', '@cypress/webpack-dev-server', '@ngtools/webpack', 'fs'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["cypress-angular-dev-server"] = {}, global.webpackDevServer, global.webpack, global.fs));
})(this, (function (exports, webpackDevServer, webpack, fs) { 'use strict';

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () { return e[k]; }
          });
        }
      });
    }
    n["default"] = e;
    return Object.freeze(n);
  }

  var fs__namespace = /*#__PURE__*/_interopNamespace(fs);

  var generateTsConfigContent = function (specPattern) { return "\n{\n  \"extends\": \"./tsconfig.json\",\n  \"compilerOptions\": {\n    \"outDir\": \"./out-tsc/cy\",\n    \"types\": [\"cypress\"],\n    \"allowSyntheticDefaultImports\": true\n  },\n  \"include\": [\"src/**/*.d.ts\", \"" + specPattern + "\"]\n}\n"; };
  var generateTsConfig = function (specPattern) {
      var tsconfigContent = generateTsConfigContent(specPattern);
      fs__namespace.writeFileSync('tsconfig.cy.json', tsconfigContent);
  };
  var webpackConfig = {
      mode: 'development',
      module: {
          rules: [
              {
                  test: /\.[jt]sx?$/,
                  loader: '@ngtools/webpack',
              },
              {
                  test: /(\.scss|\.sass)$/,
                  use: ['raw-loader', 'sass-loader'],
              },
          ],
      },
      resolve: {
          extensions: ['.ts', '.js'],
      },
      plugins: [
          new webpack.AngularWebpackPlugin({
              tsconfig: './tsconfig.cy.json'
          }),
      ],
  };
  function generateWebpackConfig(specPattern) {
      generateTsConfig(specPattern);
      return webpackConfig;
  }
  ;

  function devServer(cypressDevServerConfig) {
      var config = cypressDevServerConfig.config;
      var specPattern = config.specPattern;
      var webpackConfig = generateWebpackConfig(specPattern);
      return webpackDevServer.devServer(cypressDevServerConfig, { webpackConfig: webpackConfig });
  }

  /*
   * Public API Surface of angular-dev-server
   */

  /**
   * Generated bundle index. Do not edit.
   */

  exports.devServer = devServer;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=cypress-angular-dev-server.umd.js.map
